-#!/bin/bash
+#!/usr/bin/env bash
# SPDX-License-Identifier: MIT
-set -x
-set -e
+set -o errexit
+set -o nounset
+set -o pipefail
+set -o xtrace
+
+cd "$(dirname "$0")"
unset LC_CTYPE
unset LANG
export ARCH=arm64
export CROSS_COMPILE=aarch64-linux-gnu-
export DEBOOTSTRAP=qemu-debootstrap
+ sudo apt install -y libc6-dev-arm64-cross
fi
}
{
(
handle_crosscompile
- test -d linux || git clone --depth 1 https://github.com/AsahiLinux/linux -b asahi
+ test -d linux || git clone https://github.com/AsahiLinux/linux
cd linux
- git fetch
- git reset --hard origin/asahi; git clean -f -x -d &> /dev/null
+ git fetch -a -t
+ git reset --hard asahi-6.0-rc6-1; git clean -f -x -d &> /dev/null
curl -s https://tg.st/u/40c9642c7569c52189f84621316fc9149979ee65.patch | git am -
- curl -s https://tg.st/u/0001-4k-iommu-patch-2022-03-11.patch | git am -
- curl -s https://tg.st/u/config-2022-03-17-distro-sven-jannau.txt > .config
+ cat ../../config > .config
make olddefconfig
make -j `nproc` V=0 bindeb-pkg > /dev/null
)
(
test -d m1n1 || git clone --recursive https://github.com/AsahiLinux/m1n1
cd m1n1
- git fetch
- git reset --hard origin/main; git clean -f -x -d &> /dev/null
+ git fetch -a -t
+ # https://github.com/AsahiLinux/PKGBUILDs/blob/main/m1n1/PKGBUILD
+ git reset --hard v1.1.4; git clean -f -x -d &> /dev/null
make -j `nproc`
)
}
{
(
handle_crosscompile
- test -d u-boot || git clone --depth 1 https://github.com/AsahiLinux/u-boot
+ test -d u-boot || git clone https://github.com/AsahiLinux/u-boot
cd u-boot
- git fetch
- git reset --hard origin/asahi; git clean -f -x -d &> /dev/null
+ git fetch -a -t
+ # For tag, see https://github.com/AsahiLinux/PKGBUILDs/blob/main/uboot-asahi/PKGBUILD
+ git reset --hard asahi-v2022.07-3; git clean -f -x -d &> /dev/null
+ git revert --no-edit 4d2b02faf69eaddd0f73758ab26c456071bd2017
+ curl -s https://tg.st/u/0001-usb_setup_descriptor-Add-1ms-delay-in-order-to-unbre.patch | git am -
+
make apple_m1_defconfig
make -j `nproc`
)
handle_crosscompile
sudo rm -rf testing
mkdir -p cache
- sudo eatmydata ${DEBOOTSTRAP} --cache-dir=`pwd`/cache --arch=arm64 --include initramfs-tools,pciutils,wpasupplicant,tcpdump,vim,tmux,vlan,ntpdate,parted,curl,wget,grub-efi-arm64,mtr-tiny,dbus,ca-certificates,sudo,openssh-client,mtools,gdisk testing testing http://deb.debian.org/debian
+ sudo eatmydata ${DEBOOTSTRAP} --cache-dir=`pwd`/cache --arch=arm64 --include initramfs-tools,pciutils,wpasupplicant,tcpdump,vim,tmux,vlan,ntpdate,parted,curl,wget,grub-efi-arm64,mtr-tiny,dbus,ca-certificates,sudo,openssh-client,mtools,gdisk,cryptsetup testing testing http://deb.debian.org/debian
export KERNEL=`ls -1rt linux-image*.deb | grep -v dbg | tail -1`
mkdir -p build
cd build
-sudo apt-get install -y build-essential bash git locales gcc-aarch64-linux-gnu libc6-dev-arm64-cross device-tree-compiler imagemagick ccache eatmydata debootstrap pigz libncurses-dev qemu-user-static binfmt-support rsync git flex bison bc kmod cpio libncurses5-dev libelf-dev:native libssl-dev dwarves
+sudo apt-get install -y build-essential bash git locales gcc-aarch64-linux-gnu libc6-dev device-tree-compiler imagemagick ccache eatmydata debootstrap pigz libncurses-dev qemu-user-static binfmt-support rsync git flex bison bc kmod cpio libncurses5-dev libelf-dev:native libssl-dev dwarves
build_linux
build_m1n1
build_uboot
+
+exit
+
build_rootfs
#build_di_stick
build_dd
build_asahi_installer_image
build_live_stick
publish_artefacts
+
+echo 'Reminder: On the next release publish __all__ kernel packages'